* PACKAGE DEIGEN  !" $BNO3X(B $B8GM-CM2r@O(B
*
*"  [HIS] 93/01/15(takepiro) IMSL $B%k!<%A%s;HMQ(B
*
**********************************************************************
      SUBROUTINE LEIGEN
     M            ( AMAT   , 
     O              EIGVLR , EIGVLI  ,
     O              EIGVCR , EIGVCI  ,
     I              MATDIM              )
*
      IMPLICIT NONE
*
#include        "zcdim.F"                    !" 
#include        "zldim.F"                    !" $B78?t9TNs$NBg$-$5(B
*
*   [MODIFY] 
      REAL      AMAT  ( MATDMX, MATDMX )     !" $B78?t9TNs(B
*
*   [OUTPUT] 
      REAL      EIGVLR( MATDMX )             !" $B8GM-CM<B?tIt(B
      REAL      EIGVLI( MATDMX )             !" $B8GM-CM5u?tIt(B
      REAL      EIGVCR( MATDMX, MATDMX )     !" $B8GM-%Y%/%H%k<B?tIt(B
      REAL      EIGVCI( MATDMX, MATDMX )     !" $B8GM-%Y%/%H%k5u?tIt(B
*
*   [INPUT] 
      INTEGER   MATDIM                       !" $B7W;;$9$k<!85(B
*
*   [INTERNAL WORK] 
c$$$      COMMON    /COMWRK/ 
*
      COMPLEX   EVAL( MATDMX )               !" $B8GM-CM(B
      COMPLEX   EVEC( MATDMX, MATDMX )       !" $B8GM-%Y%/%H%k(B
*
      INTEGER   J, K
*
*"  < 1. $B8GM-CM(B, $B8GM-%Y%/%H%k$N7W;;(B > 
*
      CALL DEVCRG
     I      ( MATDIM , AMAT , MATDMX , 
     O        EVAL   , EVEC , 
     I        MATDMX                   )
*
*"  < 2 . $B8GM-CM$NF~$l49$((B >
*
      DO 100 K = 1, MATDIM
         EIGVLR( K ) = REAL( EVAL(MATDIM-K+1) )
         EIGVLI( K ) = AIMAG( EVAL(MATDIM-K+1) )
 100  CONTINUE 
*
*"  < 3. $B8GM-%Y%/%H%k$NF~$l49$((B >
*
      DO 1000 K = 1, MATDIM
         DO 1000 J = 1, MATDIM
            EIGVCR( J,K ) = REAL( EVEC( J,MATDIM-K+1 ) )
            EIGVCI( J,K ) = AIMAG( EVEC( J,MATDIM-K+1 ) )
 1000 CONTINUE
*
      RETURN
      END
